/* drive.h - interface definition for `drive.c'. */
/* Copyright (C) 2017 Robin Miyagi
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef ____DRIVE_H____
#define ____DRIVE_H____

/********************************************************************/
/*                                                                  */
/*			   Project Includes                         */
/*                                                                  */
/********************************************************************/
/********************************************************************/
/*                                                                  */
/*			   System Includes                          */
/*                                                                  */
/********************************************************************/
#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>
/********************************************************************/
/*                                                                  */
/*			  Macro Definitions                         */
/*                                                                  */
/********************************************************************/
#define SECTOR_SIZE 0x200
/********************************************************************/
/*                                                                  */
/*			      Data Types                            */
/*                                                                  */
/********************************************************************/
/********************************************************************/
/*                                                                  */
/*			   Global Variables                         */
/*                                                                  */
/********************************************************************/
/********************************************************************/
/*                                                                  */
/*			 Interface Functions                        */
/*                                                                  */
/********************************************************************/
/*
 * Reads drive.  If successful, returns true, otherwise it returns
 * false.
 */
extern bool read_drive (uint64_t lba, uint16_t sectors, void *buffer);
/********************************************************************/
/*                                                                  */
/*			   Inline Functions                         */
/*                                                                  */
/********************************************************************/
/*
 * Calculate how many sectors are between start and end.  The
 * difference must be a multiple of `SECTOR_SIZE'.
 */
static inline uint32_t sectors (const void *start, const void *end);
/********************************************************************/
/*                                                                  */
/*		    Inline Function Implementation                  */
/*                                                                  */
/********************************************************************/
static inline uint32_t
sectors (const void *start, const void *end)
{
  uint32_t ret;

  ret = ((uint32_t) end - (uint32_t) start) / SECTOR_SIZE;
  return ret;
}
#endif	/* ! ____DRIVE_H____ */
